Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/dyn_em/module_em.F
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/dyn_em/module_em.F	(revision 195)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/dyn_em/module_em.F	(revision 196)
@@ -16,5 +16,6 @@
                            u, v, w, t, ph, mu,              &
                            moist,                           &
-                           ru, rv, rw, ww, php, alt, muu, muv,  &
+                           ru, rv, rw, ww, php, alt,        &
+                           muu, muv,                        &
                            mub, mut, phb, pb, p, al, alb,   &
                            cqu, cqv, cqw,                   &
@@ -280,4 +281,5 @@
    REAL    :: kdift, khdq, kvdq, cfn, cfn1, cf1, cf2, cf3
    INTEGER :: i,j,k
+   INTEGER :: time_step
 
 !<DESCRIPTION>
@@ -362,7 +364,8 @@
 
      !  advection tendencies
+     CALL nl_get_time_step ( 1, time_step )
 
      CALL advect_u ( u, u , ru_tend, ru, rv, ww,   &
-                     mut, config_flags,            &
+                     mut, time_step, config_flags, &
                      msfu, msfv, msft,             &
                      fnm, fnp, rdx, rdy, rdnw,     &
@@ -372,5 +375,5 @@
 
      CALL advect_v ( v, v , rv_tend, ru, rv, ww,   &
-                     mut, config_flags,            &
+                     mut, time_step, config_flags, &
                      msfu, msfv, msft,             &
                      fnm, fnp, rdx, rdy, rdnw,     &
@@ -381,5 +384,5 @@
      IF (non_hydrostatic)                          &
      CALL advect_w ( w, w, rw_tend, ru, rv, ww,    &
-                     mut, config_flags,            &
+                     mut, time_step, config_flags, &
                      msfu, msfv, msft,             &
                      fnm, fnp, rdx, rdy, rdn,      &
@@ -391,5 +394,5 @@
 
      CALL advect_scalar ( t, t, t_tend, ru, rv, ww,     &
-                          mut, config_flags,            &
+                          mut, time_step, config_flags, &
                           msfu, msfv, msft, fnm, fnp,   &
                           rdx, rdy, rdnw,               &
@@ -418,5 +421,4 @@
                   ims, ime, jms, jme, kms, kme,      &
                   its, ite, jts, jte, kts, kte      )
-
 
   CALL horizontal_pressure_gradient( ru_tend,rv_tend,                &
@@ -454,5 +456,4 @@
                                  its, ite, jts, jte, kts, kte )
   ELSE
-
     CALL coriolis ( ru, rv, rw,                   &
                     ru_tend,  rv_tend,  rw_tend,  &
@@ -463,6 +464,5 @@
                     its, ite, jts, jte, kts, kte )
 
-   END IF
-
+  END IF
 
   CALL curvature ( ru, rv, rw, u, v, w,            &
@@ -515,4 +515,5 @@
                                          its, ite, jts, jte, kts, kte )
 
+
 !!!****MARS: vertical diffusion is done in the physics (TODO: consider the nonhydrostatic case ?)
         pbl_test : IF ( (config_flags%bl_pbl_physics .eq. 0) &
@@ -548,5 +549,4 @@
 
         ENDIF pbl_test
-
 
    !  Theta tendency computations.
@@ -654,5 +654,4 @@
    INTEGER :: i, j, k
 
-
 !<DESCRIPTION>
 !
@@ -679,5 +678,7 @@
    DO k = kts,kte-1
    DO i = its,ite
+     ! multiply by m to uncouple u
      IF(rk_step == 1)ru_tendf(i,k,j) = ru_tendf(i,k,j) +  u_save(i,k,j)*msfu(i,j)
+     ! divide by m to couple u
      ru_tend(i,k,j) = ru_tend(i,k,j) + ru_tendf(i,k,j)/msfu(i,j)
    ENDDO
@@ -688,5 +689,7 @@
    DO k = kts,kte-1
    DO i = its,MIN(ite,ide-1)
+     ! multiply by m to uncouple v
      IF(rk_step == 1)rv_tendf(i,k,j) = rv_tendf(i,k,j) +  v_save(i,k,j)*msfv(i,j)
+     ! divide by m to couple v
      rv_tend(i,k,j) = rv_tend(i,k,j) + rv_tendf(i,k,j)/msfv(i,j)
    ENDDO
@@ -697,7 +700,10 @@
    DO k = kts,kte
    DO i = its,MIN(ite,ide-1)
+     ! multiply by m to uncouple w
      IF(rk_step == 1)rw_tendf(i,k,j) = rw_tendf(i,k,j) +  w_save(i,k,j)*msft(i,j)
+     ! divide by m to couple w
      rw_tend(i,k,j) = rw_tend(i,k,j) + rw_tendf(i,k,j)/msft(i,j)
      IF(rk_step == 1)ph_tendf(i,k,j) = ph_tendf(i,k,j) +  ph_save(i,k,j)
+     ! divide by m to couple scalar
      ph_tend(i,k,j) = ph_tend(i,k,j) + ph_tendf(i,k,j)/msft(i,j)
    ENDDO
@@ -709,6 +715,8 @@
    DO i = its,MIN(ite,ide-1)
      IF(rk_step == 1)t_tendf(i,k,j) = t_tendf(i,k,j) +  t_save(i,k,j)
-     t_tend(i,k,j) =  t_tend(i,k,j) +  t_tendf(i,k,j)/msft(i,j)  &
+     ! divide by m to couple theta
+      t_tend(i,k,j) =  t_tend(i,k,j) +  t_tendf(i,k,j)/msft(i,j)  &
                                      +  mut(i,j)*h_diabatic(i,k,j)/msft(i,j)
+     ! divide by m to couple heating
    ENDDO
    ENDDO
@@ -757,10 +765,10 @@
 
    REAL, DIMENSION(ims:ime, kms:kme, jms:jme , scs:sce ),                &
-                                         INTENT(INOUT)  :: scalar, scalar_old
+                                         INTENT(IN   )  :: scalar, scalar_old
 
    REAL, DIMENSION(ims:ime, kms:kme, jms:jme , scs:sce ),                      &
                                          INTENT(INOUT)  :: scalar_tends
                                                     
-   REAL, DIMENSION(ims:ime, kms:kme, jms:jme  ) :: advect_tend
+   REAL, DIMENSION(ims:ime, kms:kme, jms:jme  ), INTENT(INOUT) :: advect_tend
 
    REAL, DIMENSION(ims:ime, kms:kme, jms:jme  ), INTENT(OUT  ) :: RQVFTEN
@@ -801,4 +809,5 @@
   
    INTEGER :: im, i,j,k
+   INTEGER :: time_step
 
    REAL    :: khdq, kvdq, tendency
@@ -822,28 +831,43 @@
                       its, ite, jts, jte, kts, kte )
 
+     CALL nl_get_time_step ( 1, time_step )
+
       IF( (rk_step == 3) .and. pd_advection ) THEN
 
-       CALL advect_scalar_pd       ( scalar(ims,kms,jms,im),             &
-                                     scalar_old(ims,kms,jms,im),         &
-                                     advect_tend(ims,kms,jms),           &
-                                     ru, rv, ww, mut, mub, mu_old,       &
-                                     config_flags,                       &
-                                     msfu, msfv, msft, fnm, fnp,         &
-                                     rdx, rdy, rdnw,dt,                  &
-                                     ids, ide, jds, jde, kds, kde,       &
-                                     ims, ime, jms, jme, kms, kme,       &
-                                     its, ite, jts, jte, kts, kte     )
-
+        CALL advect_scalar_pd       ( scalar(ims,kms,jms,im),             &
+                                      scalar_old(ims,kms,jms,im),         &
+                                      advect_tend(ims,kms,jms),           &
+                                      ru, rv, ww, mut, mub, mu_old,       &
+                                      config_flags,                       &
+                                      msfu, msfv, msft, fnm, fnp,         &
+                                      rdx, rdy, rdnw,dt,                  &
+                                      ids, ide, jds, jde, kds, kde,       &
+                                      ims, ime, jms, jme, kms, kme,       &
+                                      its, ite, jts, jte, kts, kte     )
+
+
+
+        CALL advect_scalar_mono       ( scalar(ims,kms,jms,im),             &
+                                        scalar_old(ims,kms,jms,im),         &
+                                        advect_tend(ims,kms,jms),           &
+                                        ru, rv, ww, mut, mub, mu_old,       &
+                                        config_flags,                       &
+                                        msfu, msfv, msft, fnm, fnp,         &
+                                        rdx, rdy, rdnw,dt,                  &
+                                        ids, ide, jds, jde, kds, kde,       &
+                                        ims, ime, jms, jme, kms, kme,       &
+                                        its, ite, jts, jte, kts, kte     )
       ELSE
 
-       CALL advect_scalar     ( scalar(ims,kms,jms,im),        &
-                                scalar(ims,kms,jms,im),        &
-                                advect_tend(ims,kms,jms),      &
-                                ru, rv, ww, mut, config_flags, &
-                                msfu, msfv, msft, fnm, fnp,    &
-                                rdx, rdy, rdnw,                &
-                                ids, ide, jds, jde, kds, kde,  &
-                                ims, ime, jms, jme, kms, kme,  &
-                                its, ite, jts, jte, kts, kte  )
+        CALL advect_scalar     ( scalar(ims,kms,jms,im),        &
+                                 scalar(ims,kms,jms,im),        &
+                                 advect_tend(ims,kms,jms),      &
+                                 ru, rv, ww, mut, time_step,    &
+                                 config_flags,                  &
+                                 msfu, msfv, msft, fnm, fnp,    &
+                                 rdx, rdy, rdnw,                &
+                                 ids, ide, jds, jde, kds, kde,  &
+                                 ims, ime, jms, jme, kms, kme,  &
+                                 its, ite, jts, jte, kts, kte  )
       END IF
 
@@ -863,5 +887,6 @@
                                         scalar_tends(ims,kms,jms,im), mut, &
                                         config_flags,                      &
-                                        msfu, msfv, msft, khdq , xkmhd, rdx, rdy, &
+                                        msfu, msfv, msft,                  & 
+                                        khdq , xkmhd, rdx, rdy,            &
                                         ids, ide, jds, jde, kds, kde,      &
                                         ims, ime, jms, jme, kms, kme,      &
@@ -940,6 +965,8 @@
    REAL, DIMENSION(ims:ime, kms:kme, jms:jme , scs:sce),                &
          INTENT(INOUT)                                  :: scalar_1,    &
-                                                           scalar_2,  &
-                                                           sc_tend
+                                                           scalar_2
+
+   REAL, DIMENSION(ims:ime, kms:kme, jms:jme , scs:sce),                &
+         INTENT(IN)                                     :: sc_tend
 
    REAL, DIMENSION(ims:ime, kms:kme, jms:jme ),                &
@@ -1014,4 +1041,5 @@
        DO  k = k_start,k_end
        DO  i = i_start,i_end
+          ! scalar was coupled with m
            tendency(i,k,j) = advect_tend(i,k,j) * msft(i,j)
        ENDDO
@@ -1064,4 +1092,5 @@
        DO  k = k_start,k_end
        DO  i = i_start,i_end
+           ! scalar was coupled with m
            tendency(i,k,j) = advect_tend(i,k,j) * msft(i,j)
        ENDDO
@@ -1104,5 +1133,4 @@
 SUBROUTINE rk_update_scalar_pd( scs, sce,                      &
                                 scalar, sc_tend,               &
-                                msft,                          &
                                 mu_old, mu_new, mu_base,       &
                                 rk_step, dt, spec_zone,        &
@@ -1131,6 +1159,5 @@
    REAL, DIMENSION(ims:ime, jms:jme  ), INTENT(IN   ) ::  mu_old,  &
                                                           mu_new,  &
-                                                          mu_base, &
-                                                          msft
+                                                          mu_base
 
    INTEGER :: i,j,k,im
@@ -1523,4 +1550,5 @@
 !!****MARS
    IF ( (config_flags%bl_pbl_physics .gt. 0) .OR. (config_flags%modif_wrf) ) THEN
+
       DO J=jts,jtf
       DO K=kts,ktf
@@ -1564,6 +1592,4 @@
 
     ENDIF
-
-
 
 ! fdda
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/dyn_em/solve_em.F
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/dyn_em/solve_em.F	(revision 195)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/dyn_em/solve_em.F	(revision 196)
@@ -2046,5 +2046,4 @@
                                  moist_old(ims,kms,jms,im),                &
                                  moist_tend(ims,kms,jms,im),               &
-                                 grid%msft,                                &
                                  grid%em_mu_1, grid%em_mu_1, grid%em_mub,  &
                                  rk_step, dt_rk, grid%spec_zone,           &
@@ -2111,5 +2110,4 @@
                                  scalar_old(ims,kms,jms,im),              &
                                  scalar_tend(ims,kms,jms,im),             &
-                                 grid%msft,                               &
                                  grid%em_mu_1, grid%em_mu_1, grid%em_mub, &
                                  rk_step, dt_rk, grid%spec_zone,          &
@@ -2178,5 +2176,4 @@
                                  chem_old(ims,kms,jms,im),                &
                                  chem_tend(ims,kms,jms,im),               &
-                                 grid%msft,                               &
                                  grid%em_mu_1, grid%em_mu_1, grid%em_mub, &
                                  rk_step, dt_rk, grid%spec_zone,          &
@@ -2246,5 +2243,4 @@
                                  grid%em_tke_1,                           &
                                  tke_tend(ims,kms,jms),                   &
-                                 grid%msft,                               &
                                  grid%em_mu_1, grid%em_mu_1, grid%em_mub, &
                                  rk_step, dt_rk, grid%spec_zone,          &
